#ifndef null_hpp_INCLUDED_
#define null_hpp_INCLUDED_

namespace
{
  // Replaces the standard NULL macro
  struct
  {
    template <typename T>
    operator T* () const { return static_cast<T*> (0); }
  } null;

  // Analogous construct for pointers to members
  struct
  {
    template <class T, typename U>
    operator U T::* () const { return static_cast<U T::*> (0); }
  } null_ptr_to_member;
}

#endif
